/*
 * @file
 * Javascript for showing and hiding dependent attributes.
 *
 * Retrieves the dependencies from the database using a callback and shows
 * and hides attributes depending upon the value selected for the attribute
 * they depend upon.
 */

(function ($) {

  Drupal.behaviors.uc_dropdown_attributes = {
    attach: function (context, settings) {
      // Retrieve the node id
      var nid = $('div.add-to-cart').find(':input[name="node_id"]').val();
      $('div.attributes').find('div.attribute').each( function(i,val) {
        var attributes = $(val).attr('class').split(' ');
        if (attributes[1] != undefined) {
          var aid = attributes[1].split('-')[1];
          $.get(Drupal.settings.basePath +
                'node/' + nid + '/view/dependencies/' + aid + '/callback',
                null, readAttribute);
        }
      });
    }
  };

  var readAttribute = function(response) {
    if (response.status) {
      $('.attribute-' + response.parent_aid).find('select').change(function() {
        value=$('.attribute-' + response.parent_aid).find('select').val();
        if (value != undefined) {
          if (response.parent_values[value] == undefined) {
            $('.attribute-' + response.aid).find('select').trigger('change');
            $.get(Drupal.settings.basePath + 'node/' + response.nid +
                    '/view/dependencies/' + response.aid + '/children',
                    null, removeChildren);
            $('.attribute-' + response.aid).html('');
          } 
          else {
            if (response.parent_values[value] != undefined) {
              $('.attribute-' + response.aid).html(response.html);
              $.get(Drupal.settings.basePath + 'node/' + response.nid +
                    '/view/dependencies/' + response.aid + '/children',
                    null, readChildren);
            }
            else {
              $('.attribute-' + response.aid).find('select').trigger('change');
              $.get(Drupal.settings.basePath + 'node/' + response.nid +
                      '/view/dependencies/' + response.aid + '/children',
                      null, removeChildren);
              $('.attribute-' + response.aid).html('');
            }
          }
        }
      });
    }
  }

  var readChildren = function(response) {
    if (response.status) {
      for (i in response.aid) {
        $.get(Drupal.settings.basePath + 'node/' + response.nid +
              '/view/dependencies/' + response.aid[i] + '/callback',
              null, readAttribute);
      }
    }
  }

  var removeChildren = function(response) {
    if (response.status) {
      for (i in response.aid) {
        $('.attribute-' + response.aid[i]).find('select').trigger('change');
        $('.attribute-' + response.aid).html('');
      }
    }
  }
})(jQuery);
